<?php
/**
 * SEO Consultant Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package seo_consultant
 */

if( ! function_exists( 'seo_consultant_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function seo_consultant_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Seo_Consultant_Control_Sortable' ); 
    
    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'seo-consultant' );
    }
	
    /* Option list of all post */	
    $seo_consultant_options_posts = array();
    $seo_consultant_options_posts_obj = get_posts('posts_per_page=-1');
    $seo_consultant_options_posts[''] = esc_html__( 'Choose Post', 'seo-consultant' );
    foreach ( $seo_consultant_options_posts_obj as $seo_consultant_posts ) {
    	$seo_consultant_options_posts[$seo_consultant_posts->ID] = $seo_consultant_posts->post_title;
    }
    
    /* Option list of all categories */
    $seo_consultant_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $seo_consultant_option_categories = array();
    $seo_consultant_category_lists = get_categories( $seo_consultant_args );
    $seo_consultant_option_categories[''] = esc_html__( 'Choose Category', 'seo-consultant' );
    foreach( $seo_consultant_category_lists as $seo_consultant_category ){
        $seo_consultant_option_categories[$seo_consultant_category->term_id] = $seo_consultant_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'seo-consultant' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'seo-consultant' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'seo-consultant' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'seo-consultant' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'seo-consultant'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'seo_consultant_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'seo_consultant_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'seo-consultant' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Post Layouts */

    /** Blog Content Alignment */
    $wp_customize->add_setting('seo_consultant_blog_layout_option', array(
        'default'           => 'Left',
        'sanitize_callback' => 'seo_consultant_sanitize_choices',
    ));

    $wp_customize->add_control('seo_consultant_blog_layout_option', array(
        'label'    => __('Post Content Alignment', 'seo-consultant'),
        'section'  => 'seo_consultant_post_layout_section',
        'settings' => 'seo_consultant_blog_layout_option',
        'type'     => 'select',
        'choices'  => array(
		   'Left'     => __('Left', 'seo-consultant'),
		   'Center'     => __('Center', 'seo-consultant'),
		   'Right'     => __('Right', 'seo-consultant'),
        ),
    ));
    
    /** Home Page Settings */
    $wp_customize->add_panel( 
        'seo_consultant_post_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'seo-consultant' ),
            'description' => esc_html__( 'Customize Post & Pages Settings Settings', 'seo-consultant' ),
        ) 
    );
    
    $wp_customize->add_section(
        'seo_consultant_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'seo-consultant' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_post_settings',
        )
    );

    $wp_customize->add_setting('seo_consultant_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'seo_consultant_sanitize_post_layout',
    ));

    $wp_customize->add_control('seo_consultant_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'seo-consultant'),
        'section'  => 'seo_consultant_post_layout_section',
        'settings' => 'seo_consultant_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'seo-consultant'),
            'left-sidebar'   => __('Left Sidebar', 'seo-consultant'),
            'one-column'   => __('One Column', 'seo-consultant'),
            'three-column'   => __('Three Columns', 'seo-consultant'),
            'four-column'   => __('Four Columns', 'seo-consultant'),
            'grid-layout'   => __('Grid Layout', 'seo-consultant')
        ),
    ));

     /** Post Layouts Ends */
     
    /** Post Settings */
    $wp_customize->add_section(
        'seo_consultant_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'seo-consultant' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'seo_consultant_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'seo-consultant' ),
            'section'     => 'seo_consultant_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'seo_consultant_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'seo-consultant' ),
            'section'     => 'seo_consultant_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'seo_consultant_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'seo-consultant' ),
            'section'     => 'seo_consultant_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'seo_consultant_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'seo-consultant' ),
            'section'     => 'seo_consultant_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'seo_consultant_read_more_setting`', array(
        'default'           => true,
        'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'seo_consultant_read_more_setting`', array(
        'type'        => 'checkbox',
        'section'     => 'seo_consultant_post_settings', 
        'label'       => __( 'Display Read More Button', 'seo-consultant' ),
    ) );

    $wp_customize->add_setting('seo_consultant_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'seo_consultant_sanitize_sortable',
    ));
    $wp_customize->add_control(new Seo_Consultant_Control_Sortable($wp_customize, 'seo_consultant_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'seo-consultant'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'seo-consultant') ,
        'section' => 'seo_consultant_post_settings',
        'choices' => array(
            'heading' => __('heading', 'seo-consultant') ,
            'author' => __('author', 'seo-consultant') ,
            'featured-image' => __('featured-image', 'seo-consultant') ,
            'content' => __('content', 'seo-consultant') ,
            'button' => __('button', 'seo-consultant') ,
        ) ,
    )));

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'seo_consultant_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'seo-consultant' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'seo_consultant_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'seo-consultant' ),
            'section'     => 'seo_consultant_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'seo_consultant_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'seo-consultant' ),
            'section'     => 'seo_consultant_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

   //Global Color
    $wp_customize->add_section(
        'seo_consultant_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'seo-consultant' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_general_settings',
        )
    );

    $wp_customize->add_setting('seo_consultant_primary_color', array(
        'default'           => '#FF4F28',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'seo_consultant_primary_color', array(
        'label'    => __('Theme Primary Color', 'seo-consultant'),
        'section'  => 'seo_consultant_global_color',
        'settings' => 'seo_consultant_primary_color',
    )));    

    $wp_customize->add_setting('seo_consultant_second_color', array(
        'default'           => '#FF961C',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'seo_consultant_second_color', array(
        'label'    => __('Theme Secondary Color', 'seo-consultant'),
        'section'  => 'seo_consultant_global_color',
        'settings' => 'seo_consultant_second_color',
    )));


         // Typography Settings Section
    $wp_customize->add_section('seo_consultant_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'seo-consultant'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'seo_consultant_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'seo-consultant'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('seo_consultant_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'seo_consultant_sanitize_choicess',
    ));
    $wp_customize->add_control('seo_consultant_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'seo-consultant'),
        'section' => 'seo_consultant_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('seo_consultant_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'seo_consultant_sanitize_choicess',
    ));
    $wp_customize->add_control('seo_consultant_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'seo-consultant'),
        'section' => 'seo_consultant_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'seo_consultant_general_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'seo-consultant' ),
            'description' => esc_html__( 'Customize General Settings', 'seo-consultant' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'seo_consultant_loader_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'seo-consultant' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'seo_consultant_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'seo-consultant' ),
            'section'     => 'seo_consultant_loader_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('seo_consultant_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('seo_consultant_loader_layout_control', array(
        'label' => __('Preloader Layout', 'seo-consultant'),
        'section' => 'seo_consultant_loader_settings',
        'settings' => 'seo_consultant_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'seo-consultant'),
            'load-one' => __('Preloader 2', 'seo-consultant'),
            'ctn-preloader' => __('Preloader 3', 'seo-consultant'),
        ),
    ));

 /** Slider Section Settings */
    $wp_customize->add_section(
        'seo_consultant_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'seo-consultant' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_home_page_settings',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'seo_consultant_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'seo-consultant' ),
            'section'     => 'seo_consultant_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'seo_consultant_menu_font_weight', array(
        'default'           => 'Bold',
        'sanitize_callback' => 'seo_consultant_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'seo_consultant_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'seo-consultant' ),
        'section'  => 'seo_consultant_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'seo-consultant' ),
            '200' => __( '200 - Extra Light', 'seo-consultant' ),
            '300' => __( '300 - Light', 'seo-consultant' ),
            '400' => __( '400 - Normal', 'seo-consultant' ),
            '500' => __( '500 - Medium', 'seo-consultant' ),
            '600' => __( '600 - Semi Bold', 'seo-consultant' ),
            '700' => __( '700 - Bold', 'seo-consultant' ),
            '800' => __( '800 - Extra Bold', 'seo-consultant' ),
            '900' => __( '900 - Black', 'seo-consultant' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'seo_consultant_menu_text_transform', array(
        'default'           => 'Uppercase',
        'sanitize_callback' => 'seo_consultant_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'seo_consultant_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'seo-consultant' ),
        'section'  => 'seo_consultant_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'seo-consultant' ),
            'capitalize' => __( 'Capitalize', 'seo-consultant' ),
            'uppercase'  => __( 'Uppercase', 'seo-consultant' ),
            'lowercase'  => __( 'Lowercase', 'seo-consultant' ),
        ),
    ) );

    $wp_customize->add_setting('seo_consultant_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'seo_consultant_sanitize_choices'
	));
	$wp_customize->add_control('seo_consultant_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','seo-consultant'),
		'section' => 'seo_consultant_header_section_settings',
		'choices' => array(
         'None' => __('None','seo-consultant'),
         'Zoom In' => __('Zoom In','seo-consultant'),
      ),
	));

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'seo_consultant_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'seo-consultant' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'seo-consultant' ),
        ) 
    );

 /** Slider Section Settings */
    $wp_customize->add_section(
        'seo_consultant_slider_section_settings',
        array(
            'title' => esc_html__( 'Banner Section Settings', 'seo-consultant' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'seo_consultant_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_slider_setting',
        array(
            'label'       => __( 'Show Banner', 'seo-consultant' ),
            'section'     => 'seo_consultant_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('seo_consultant_slider_background_image',
        array(
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control( $wp_customize,'seo_consultant_slider_background_image',
            array(
                'label' => __('Banner Background Image','seo-consultant'),
                'section' => 'seo_consultant_slider_section_settings',
                'settings' => 'seo_consultant_slider_background_image',
            )
        )
    );

    // Section Text
    $wp_customize->add_setting('seo_consultant_slider_text_extra', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('seo_consultant_slider_text_extra', 
        array(
        'label'       => __('Banner Extra Title', 'seo-consultant'),
        'section'     => 'seo_consultant_slider_section_settings',   
        'settings'    => 'seo_consultant_slider_text_extra',
        'type'        => 'text'
        )
    );

        // Section Text
    $wp_customize->add_setting('seo_consultant_slider_heading', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('seo_consultant_slider_heading', 
        array(
        'label'       => __('Banner Heading', 'seo-consultant'),
        'section'     => 'seo_consultant_slider_section_settings',   
        'settings'    => 'seo_consultant_slider_heading',
        'type'        => 'text'
        )
    );

        $wp_customize->add_setting(
        'seo_consultant_banner_btn_text',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'seo_consultant_banner_btn_text',
        array(
            'label' => esc_html__( 'Add Button Text', 'seo-consultant' ),
            'section' => 'seo_consultant_slider_section_settings',
            'type' => 'text',
        )
    );

    /** Banner Button */
    $wp_customize->add_setting(
        'seo_consultant_banner_btn_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'seo_consultant_banner_btn_url',
        array(
            'label' => esc_html__( 'Add Button URL', 'seo-consultant' ),
            'section' => 'seo_consultant_slider_section_settings',
            'type' => 'url',
        )
    );

        // Add About US static IMG 1
    $wp_customize->add_setting( 'seo_consultant_banner_img_1', array(
        'default'           => '',
        'sanitize_callback' => 'esc_url_raw',
    ) );


    $wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'seo_consultant_banner_img_1', array(
        'label'    => __( 'Upload Image 1', 'seo-consultant' ),
        'section'  => 'seo_consultant_slider_section_settings',
        'settings' => 'seo_consultant_banner_img_1',
        'button_labels' => array(
            'select'       => __( 'Select Image', 'seo-consultant' ),
            'change'       => __( 'Change Image', 'seo-consultant' ),
            'remove'       => __( 'Remove', 'seo-consultant' ),
            'default'      => __( 'Default', 'seo-consultant' ),
            'placeholder'  => __( 'No image selected', 'seo-consultant' ),
        ),
    ) ) );

     // Add About US static IMG 1
    $wp_customize->add_setting( 'seo_consultant_banner_img_2', array(
        'default'           => '',
        'sanitize_callback' => 'esc_url_raw',
    ) );


    $wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'seo_consultant_banner_img_2', array(
        'label'    => __( 'Upload Image 2', 'seo-consultant' ),
        'section'  => 'seo_consultant_slider_section_settings',
        'settings' => 'seo_consultant_banner_img_2',
        'button_labels' => array(
            'select'       => __( 'Select Image', 'seo-consultant' ),
            'change'       => __( 'Change Image', 'seo-consultant' ),
            'remove'       => __( 'Remove', 'seo-consultant' ),
            'default'      => __( 'Default', 'seo-consultant' ),
            'placeholder'  => __( 'No image selected', 'seo-consultant' ),
        ),
    ) ) );

    // Satisfied text
    $wp_customize->add_setting('seo_consultant_satisfied_number', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('seo_consultant_satisfied_number', 
        array(
        'label'       => __('Satisfied User Count', 'seo-consultant'),
        'section'     => 'seo_consultant_slider_section_settings',   
        'settings'    => 'seo_consultant_satisfied_number',
        'type'        => 'text'
        )
    );
    


    /** Classes Section Settings */
    $wp_customize->add_section(
        'seo_consultant_classes_section_settings',
        array(
            'title' => esc_html__( 'Services Section Settings', 'seo-consultant' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'seo_consultant_home_page_settings',
        )
    );

    /** Classes Section control */
    $wp_customize->add_setting( 
        'seo_consultant_classes_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_classes_setting',
        array(
            'label'       => __( 'Show Services Section', 'seo-consultant' ),
            'section'     => 'seo_consultant_classes_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Text
    $wp_customize->add_setting(
        'seo_consultant_service_text', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'seo_consultant_service_text', 
        array(
            'label'       => __('Section Sub Heading', 'seo-consultant'),
            'section'     => 'seo_consultant_classes_section_settings',
            'settings'    => 'seo_consultant_service_text',
            'type'        => 'text'
        )
    );

    // Section Title
    $wp_customize->add_setting(
        'seo_consultant_service_title', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'seo_consultant_service_title', 
        array(
            'label'       => __('Section Heading', 'seo-consultant'),
            'section'     => 'seo_consultant_classes_section_settings',
            'settings'    => 'seo_consultant_service_title',
            'type'        => 'text'
        )
    );

    // Post Categories
    $categories = get_categories();
    $cat_posts = array();
    $default = '';
    $cat_posts[] = 'Select';
    foreach ($categories as $category) {
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'seo_consultant_blog_args_',
        array(
            'default'            => 'select',
            'sanitize_callback'  => 'seo_consultant_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'seo_consultant_blog_args_',
        array(
            'type'     => 'select',
            'choices'  => $cat_posts,
            'label'    => __('Select Category to Display Services', 'seo-consultant'),
            'section'  => 'seo_consultant_classes_section_settings',
        )
    );

    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'seo_consultant_footer_section',
        array(
            'title' => __( 'Footer Settings', 'seo-consultant' ),
            'priority' => 70,
            'panel' => 'seo_consultant_home_page_settings',
        )
    );

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'seo_consultant_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'seo_consultant_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'seo-consultant' ),
            'section'     => 'seo_consultant_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Footer Widget Columns */
    $wp_customize->add_setting('seo_consultant_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'seo_consultant_sanitize_choices',
    ));

    $wp_customize->add_control('seo_consultant_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'seo-consultant'),
        'section'  => 'seo_consultant_footer_section',
        'settings' => 'seo_consultant_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'seo-consultant'),
		   '2'     => __('Two', 'seo-consultant'),
		   '3'     => __('Three', 'seo-consultant'),
		   '4'     => __('Four', 'seo-consultant')
        ),
    ));

    /** Copyright Text */
    $wp_customize->add_setting(
        'seo_consultant_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'seo_consultant_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'seo-consultant' ),
            'section' => 'seo_consultant_footer_section',
            'type' => 'text',
        )
    );  
$wp_customize->add_setting('seo_consultant_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'seo_consultant_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'seo-consultant'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'seo-consultant'), 1024, 800),
                'section' => 'seo_consultant_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('seo_consultant_background_attatchment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'seo_consultant_sanitize_choices',
    ));

    $wp_customize->add_control('seo_consultant_background_attatchment', array(
        'label'    => __('Footer Background Attachment', 'seo-consultant'),
        'section'  => 'seo_consultant_footer_section',
        'settings' => 'seo_consultant_background_attatchment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','seo-consultant'),
            'scroll' => __('scroll','seo-consultant'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'seo_consultant_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'seo_consultant_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'seo-consultant'),
                'section' => 'seo_consultant_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('seo_consultant_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon(
        $wp_customize,'seo_consultant_scroll_icon',array(
        'label' => __('Scroll Top Icon','seo-consultant'),
        'transport' => 'refresh',
        'section'   => 'seo_consultant_footer_section',
        'type'      => 'icon'
    )));

    /** Scroll to top button shape */
    $wp_customize->add_setting('seo_consultant_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'seo_consultant_sanitize_choices',
    ));

    $wp_customize->add_control('seo_consultant_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'seo-consultant'),
        'section'  => 'seo_consultant_footer_section',
        'settings' => 'seo_consultant_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'seo-consultant' ),
            'curved-box' => __( 'Curved Box', 'seo-consultant' ),
            'circle'     => __( 'Circle', 'seo-consultant' ),
        ),
    ));

    /** Footer Social Icon */
    $wp_customize->add_section('seo_consultant_footer_social_section', array(
        'title' => __( 'Footer Social Settings', 'seo-consultant' ),
        'panel' => 'seo_consultant_home_page_settings',
    ));

    $wp_customize->add_setting('seo_consultant_enable_footer_icon_section', array(
        'default' => true,
        'sanitize_callback' => 'seo_consultant_sanitize_checkbox',
    ) );
    $wp_customize->add_control( 'seo_consultant_enable_footer_icon_section', array(
        'label'       => __( 'Show Footer Icon', 'seo-consultant' ),
        'section'     => 'seo_consultant_footer_social_section',
        'type'        => 'checkbox',
    ));

    // Add setting for Facebook Link
    $wp_customize->add_setting(
        'seo_consultant_footer_facebook_link',
        array(
            'default'           => 'https://www.facebook.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'seo_consultant_footer_facebook_link',
        array(
            'label'           => esc_html__( 'Facebook Link', 'seo-consultant'  ),
            'section'         => 'seo_consultant_footer_social_section',
            'settings'        => 'seo_consultant_footer_facebook_link',
            'type'      => 'url'
        )
    );

    // Add setting for Facebook Icon Changing
    $wp_customize->add_setting(
        'seo_consultant_facebook_icon',
        array(
            'default' => 'fa-brands fa-facebook',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon($wp_customize, 
        'seo_consultant_facebook_icon',
        array(
            'label'   		=> __('Facebook Icon','seo-consultant'),
            'section' 		=> 'seo_consultant_footer_social_section',
            'iconset' => 'fb',
        ))  
    );


    // Add setting for Twitter Link
    $wp_customize->add_setting(
        'seo_consultant_footer_twitter_link',
        array(
            'default'           => 'https://twitter.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'seo_consultant_footer_twitter_link',
        array(
            'label'           => esc_html__( 'Twitter Link', 'seo-consultant'  ),
            'section'         => 'seo_consultant_footer_social_section',
            'settings'        => 'seo_consultant_footer_twitter_link',
            'type'      => 'url'
        )
    );

    // Add setting for Twitter Icon Changing
    $wp_customize->add_setting(
        'seo_consultant_twitter_icon',
        array(
            'default' => 'fa-brands fa-twitter',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon($wp_customize, 
        'seo_consultant_twitter_icon',
        array(
            'label'   		=> __('Twitter Icon','seo-consultant'),
            'section' 		=> 'seo_consultant_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Instagram Link
    $wp_customize->add_setting(
        'seo_consultant_footer_instagram_link',
        array(
            'default'           => 'https://www.instagram.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'seo_consultant_footer_instagram_link',
        array(
            'label'           => esc_html__( 'Instagram Link', 'seo-consultant'  ),
            'section'         => 'seo_consultant_footer_social_section',
            'settings'        => 'seo_consultant_footer_instagram_link',
            'type'      => 'url'
        )
    );

    // Add setting for Instagram Icon Changing
    $wp_customize->add_setting(
        'seo_consultant_instagram_icon',
        array(
            'default' => 'fa-brands fa-instagram',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon($wp_customize, 
        'seo_consultant_instagram_icon',
        array(
            'label'   		=> __('Instagram Icon','seo-consultant'),
            'section' 		=> 'seo_consultant_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Linkedin Link
    $wp_customize->add_setting(
        'seo_consultant_footer_linkedin_link',
        array(
            'default'           => 'https://in.linkedin.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'seo_consultant_footer_linkedin_link',
        array(
            'label'           => esc_html__( 'Linkedin Link', 'seo-consultant'  ),
            'section'         => 'seo_consultant_footer_social_section',
            'settings'        => 'seo_consultant_footer_linkedin_link',
            'type'      => 'url'
        )
    );

    // Add setting for Linkedin Icon Changing
    $wp_customize->add_setting(
        'seo_consultant_linkedin_icon',
        array(
            'default' => 'fa-brands fa-linkedin',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon($wp_customize, 
        'seo_consultant_linkedin_icon',
        array(
            'label'   		=> __('Linkedin Icon','seo-consultant'),
            'section' 		=> 'seo_consultant_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Youtube Link
    $wp_customize->add_setting(
        'seo_consultant_footer_youtube_link',
        array(
            'default'           => 'https://www.youtube.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'seo_consultant_footer_youtube_link',
        array(
            'label'           => esc_html__( 'Youtube Link', 'seo-consultant'  ),
            'section'         => 'seo_consultant_footer_social_section',
            'settings'        => 'seo_consultant_footer_youtube_link',
            'type'      => 'url'
        )
    );

    // Add setting for Youtube Icon Changing
    $wp_customize->add_setting(
        'seo_consultant_youtube_icon',
        array(
            'default' => 'fa-brands fa-youtube',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Seo_Consultant_Changeable_Icon($wp_customize, 
        'seo_consultant_youtube_icon',
        array(
            'label'   		=> __('Youtube Icon','seo-consultant'),
            'section' 		=> 'seo_consultant_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'seo_consultant_404_section',
        array(
            'title' => __( '404 Page Settings', 'seo-consultant' ),
            'priority' => 70,
            'panel' => 'seo_consultant_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'seo-consultant'),
        'section' => 'seo_consultant_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'seo-consultant'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'seo-consultant'),
        'section' => 'seo_consultant_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'seo-consultant'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'seo-consultant'),
        'section' => 'seo_consultant_404_section',
    ));

}
add_action( 'customize_register', 'seo_consultant_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function seo_consultant_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $seo_consultant_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $seo_consultant_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'seo_consultant_customizer', get_template_directory_uri() . '/js' . $seo_consultant_build . '/customizer' . $seo_consultant_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'seo_consultant_customize_preview_js' );